// Cake Zombies.

// INCLUDES ///////////////////////////////////////////////

#define WIN32_LEAN_AND_MEAN  

// you must #define INITGUID if not done elsewhere
#define INITGUID

#include <windows.h>   // include important windows stuff
#include <windowsx.h> 
#include <mmsystem.h>
#include <objbase.h>
#include <iostream> // include important C/C++ stuff
#include <conio.h>
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <string.h>
#include <stdarg.h>
#include <stdio.h> 
#include <math.h>
#include <io.h>
#include <fcntl.h>
#include <SYS\Stat.h>


#include <ddraw.h>     // directX includes
#include <dinput.h>
#include "T3DLIB1.H"

#define ROWBYTES_DWORD(width,bitcount)   ((((width)*(bitcount)+31) >> 3) & 0xfffc) 

#define ANIM_RIGHT 0
#define ANIM_LEFT  1

// All object types
#define OBJ_START   12
#define OBJ_ZOMBIE  13
#define OBJ_DRONE   14
#define OBJ_FINISH  15

// BOB.varF[INDEX]
#define FORCE_X 0
#define FORCE_Y 1

// BOB.varI[INDEX]
#define OBJ_TYPE 0
#define OBJ_WORLD_X 1
#define OBJ_WORLD_Y 2

// animation sequences for bob
const int zombie_anims[2][4] = { {0,1,0,2},
						   {0+4,1+4,0+4,2+4}, };
// default screen size
#define SCREEN_WIDTH    640  // size of screen
#define SCREEN_HEIGHT   480
#define SCREEN_BPP      8    // bits per pixel

#define BITMAP_ID            0x4D42 // universal id for a bitmap
#define MAX_COLORS_PALETTE   256

#define NUM_TEXTURES         12 // normally this would be a multiple of 16 or something!
#define NUM_ZOMBIE_FRAMES    12 // normally this would be a multiple of 16 or something!

// PROTOTYPES /////////////////////////////////////////////

// game console
int Game_Init(void *parms=NULL, int num_parms = 0);
int Game_Shutdown(void *parms=NULL, int num_parms = 0);
int Game_Main(void *parms=NULL,  int num_parms = 0);
int Prep_File(char*);
int Load_Level(char*);
int Save_Level(char*);
int Expand_Level();
int Add_Object(int, int, int);
int Update_BOB(BOB*);

// GLOBALS ////////////////////////////////////////////////

// windows vars
HWND      main_window_handle = NULL; // globally track main window
int       window_closed      = 0;    // tracks if window is closed
HINSTANCE main_instance      = NULL; // globally track hinstance

// INPUT STUFF ///////////////////////////////////////////
LPDIRECTINPUT8        lpdi      = NULL;    // dinput object
LPDIRECTINPUTDEVICE8  lpdikey   = NULL;    // dinput keyboard
LPDIRECTINPUTDEVICE8  lpdimouse = NULL;    // dinput mouse
LPDIRECTINPUTDEVICE8  lpdijoy   = NULL;    // dinput joystick 
GUID                 joystickGUID;        // guid for main joystick
char                 joyname[80];         // name of joystick
char				 mapname[80];

// these contain the target records for all di input packets
UCHAR        keyboard_state[256]; // contains keyboard state table
DIMOUSESTATE mouse_state;         // contains state of mouse
DIJOYSTATE   joy_state;           // contains state of joystick

int mouse_x,                    // used to track mouse
    mouse_y;
    
UCHAR mouse_color=100;          // color of mouse brush

int command_state=0;            // state of user command

// position of control buttons
int buttons_x[] = {509, 559, 509, 559};
int buttons_y[] = {344, 344, 383, 383};

// on/off state of buttons
int buttons_state[] = {0,1,0,0};

char buffer[80];                // used to print text

// demo globals
BOB textures;     // texture memory
BOB zombie;	 
BOB *Obj_List;

int world_x = 0,   // current position of viewing window
    world_y = 0;

int mouse_map_x = 0,
	mouse_map_y = 0; // world mouse positions

int mouse_drag_x_start = 0,
	mouse_drag_y_start = 0,
	mouse_drag_x_end = 0,
	mouse_drag_y_end = 0;

int drag_brush = 0;

int Level_Size;
int *Level[7];

int Num_Objects = 0;



