// Cake Zombies

#include "CakeZombies.h"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings
int swap;
int temp_mm_x, temp_mm_y;

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	//case WM_LBUTTONDOWN:
	//	// if left mouse button is pressed, cycle through tile options
	//	Level[mouse_map_y][mouse_map_x]++;
	//	if (Level[mouse_map_y][mouse_map_x] >= 11)
	//		Level[mouse_map_y][mouse_map_x] = 0;
	//	Game_Main();
	//	break;

	//case WM_RBUTTONDOWN:
	//	drag_brush = Level[mouse_map_y][mouse_map_x];
	//	mouse_drag_x_start = mouse_map_x;
	//	mouse_drag_y_start = mouse_map_y;
	//	break;

	//case WM_RBUTTONUP:
	//	temp_mm_x = mouse_map_x;
	//	temp_mm_y = mouse_map_y;

	//	if (mouse_drag_x_start > mouse_map_x)
	//	{
	//		swap = temp_mm_x;
	//		temp_mm_x = mouse_drag_x_start;
	//		mouse_drag_x_start = swap;
	//	}

	//	if (mouse_drag_y_start > mouse_map_y)
	//	{
	//		swap = temp_mm_y;
	//		temp_mm_y = mouse_drag_y_start;
	//		mouse_drag_y_start = swap;
	//	}

	//	for (int i = mouse_drag_x_start ; i <= temp_mm_x ; i++)
	//		for (int j = mouse_drag_y_start ; j <= temp_mm_y ; j++)
	//		{
	//			if ((Level[j][i] <= 11) && (drag_brush <= 11))
	//				Level[j][i] = drag_brush;
	//		}
	//	break;

	//case WM_KEYDOWN:
	//	switch (wparam)
	//	{
	//	case 'e':
	//	case 'E':
	//		Expand_Level();
	//		break;

	//	case 's':
	//	case 'S':
	//		Save_Level(mapname);
	//		break;

	//	case '1':
	//		//Add_Object(OBJ_START, mouse_map_x, mouse_map_y);
	//		Level[mouse_map_y][mouse_map_x] = OBJ_START;
	//		break;

	//	case '2':
	//		//Add_Object(OBJ_ZOMBIE, mouse_map_x, mouse_map_y);
	//		Level[mouse_map_y][mouse_map_x] = OBJ_ZOMBIE;
	//		break;

	//	case '3':
	//		//Add_Object(OBJ_DRONE, mouse_map_x, mouse_map_y);
	//		Level[mouse_map_y][mouse_map_x] = OBJ_DRONE;
	//		break;

	//	case '4':
	//		//Add_Object(OBJ_FINISH, mouse_map_x, mouse_map_y);
	//		Level[mouse_map_y][mouse_map_x] = OBJ_FINISH;
	//		break;

	//	case '0':
	//		// could have some way of freeing the BOB,
	//		// but not necessary for what this program does.
	//		Level[mouse_map_y][mouse_map_x] = 0;
	//		break;

		//default:
		//	break;
		//}
		//break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// before doing ANYTHING we need to make sure we can open
// the level that's been passed.
strcpy (mapname, lpcmdline);
//strcpy (mapname, "test2.txt");

// if no file name is passed, nothing to do.
if (strlen(mapname) <= 0) return 0;

// make sure file is okay.
Prep_File (mapname);

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "DirectDraw 8-Bit Smooth Scrolling Demo", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
	   switch (GAME_MODE)
	   {
	   case MENU:
		   Main_Menu();
		   break;
	   case GAME:
		   Game_Main();
		   break;
	   case WIN:
		   Win_Stage();
	   default:
		   break;
	   }
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// allocate memory of stage.
for (int i = 0 ; i < 7 ; i++)
{
	Level[i] = (int*)malloc (sizeof(*Level[i]) * 30);
	memset (Level[i], 0 , sizeof(*Level[i]) * 30);
}

if (Level == 0) return 0;

Level_Size = 30;

// initialize directsound
DSound_Init();

// load in the digital sound
sound_ids[ENEMY_GUN] = DSound_Load_WAV("cannon.wav");
sound_ids[SHOTGUN] = DSound_Load_WAV("dsshotgn.wav");
sound_ids[HURT] = DSound_Load_WAV("dsplpain.wav");
sound_ids[DIE] = DSound_Load_WAV("dspldeth.wav");
sound_ids[ZOM_DMG] = DSound_Load_WAV("dsmnpain.wav");
sound_ids[ZOM_DIE] = DSound_Load_WAV("dsmandth.wav");



// initialize directdraw
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, false);

// first create the direct input object
DirectInput8Create(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput8, (void **)&lpdi,NULL);

// create a mouse device  /////////////////////////////////////
lpdi->CreateDevice(GUID_SysMouse, &lpdimouse, NULL);

// set data format
lpdimouse->SetDataFormat(&c_dfDIMouse);

// acquire the mouse
lpdimouse->Acquire();

/////////////////////////////////////////////////////////////////

// set the global mouse position
mouse_x = screen_width/2;
mouse_y = screen_height/2;

// load in texture maps
Load_Bitmap_File(&bitmap8bit, "scrolltextures.bmp");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// create the texture bob
if (!Create_BOB(&textures,0,0,64,64,NUM_TEXTURES, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load each texture bitmap into the texture BOB object
for (index = 0; index < NUM_TEXTURES; index++)
    Load_Frame_BOB(&textures,&bitmap8bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
Unload_Bitmap_File(&bitmap8bit);

memset (&bitmap8bit, 0, sizeof(bitmap8bit));

// load each texture bitmap into the texture BOB object
//for (index = 0; index < NUM_ZOMBIE_FRAMES; index++)
//    Load_Frame_BOB(&zombie,&bitmap8bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
//Unload_Bitmap_File(&bitmap8bit);

// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height}; // 32 pixels at the bottom for controls

// notice at bottom of screen a blank rect, this would be for your
// control panel for example
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

Load_Level ("menu.txt");

memset (Bullet_List, 0, sizeof(BULLETS) * MAX_BULLETS);

GAME_MODE = MENU;

// hide the mouse
ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

// stop all sounds
DSound_Stop_All_Sounds();

// delete all sounds
DSound_Delete_All_Sounds();

// shutdown directsound
DSound_Shutdown();


for (int i = 0 ; i < 7 ; i++)
	free(Level[i]);

// first unacquire the mouse
lpdimouse->Unacquire();

// now release the mouse
lpdimouse->Release();

// release directinput
lpdi->Release();

// kill texture memory
Destroy_BOB(&textures);

for (int i = 0 ; i < Num_Objects ; i++)
{
	Destroy_BOB(&Obj_List[i]);
}

free(Obj_List);

// shutdonw directdraw
DDraw_Shutdown();



// return success
return(1);
} // end Game_Shutdown






int Main_Menu()
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y;

int world_x_bound;

int world_mouse_x, world_mouse_y; // world mouse positions

int offset_x, offset_y;       // pixel offsets within cell

int temp_tile;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

world_x_bound = (Level_Size - 10) * 64;

if (KEY_DOWN('S') || KEY_DOWN('s')) 
{
	GAME_MODE = GAME;

	current_level = 2;
	sprintf (Next_Level, "level%d.txt", current_level);

	Unload_Level();
	Load_Level(mapname);
}

// check for movement (scrolling)
//if (KEY_DOWN(VK_UP))
//    {
//    if ((world_y-=4) < 0)
//       world_y = 0;
//
//    } // end if
//else
//if (KEY_DOWN(VK_DOWN))
//    {
//    if ((world_y+=4) >= 448)
//       world_y = 447;
//
//    } // end if


// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
//start_map_y = world_y/64; 
start_map_y = 0; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + 10 - 1;
end_map_y = start_map_y + 7 - 1;


// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;

// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
    for (index_x = start_map_x; index_x <= end_map_x; index_x++)
        {
        // set position to blit
        textures.x = texture_x;
        textures.y = texture_y;
        
        // set frame
        textures.curr_frame = Level[index_y][index_x];
		
		if (textures.curr_frame >= 12) textures.curr_frame = 0;

        // draw the texture
        Draw_BOB(&textures,lpddsback);

        // update texture position
        texture_x+=64;

        } // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += 64;

    } // end for map_y

Draw_Text_GDI("CAKE ZOMBIES",screen_width/2 - 70,screen_height/2 - 20 - 20, RGB(0,255,0),lpddsback);
Draw_Text_GDI("Press S to Start",screen_width/2 - 70,screen_height/2 + 4 - 20, RGB(0,255,0),lpddsback);
Draw_Text_GDI("Press ESC to Exit (lolnub)",screen_width/2 - 70,screen_height/2 + 28 - 20, RGB(0,255,0),lpddsback);




// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(15);

// return success
return(1);
}






int Win_Stage()
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y;

int world_x_bound;

int world_mouse_x, world_mouse_y; // world mouse positions

int offset_x, offset_y;       // pixel offsets within cell

int temp_tile;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

world_x_bound = (Level_Size - 10) * 64;

if (KEY_DOWN('S') || KEY_DOWN('s')) 
{
	GAME_MODE = GAME;

	Unload_Level();
	Load_Level(Next_Level);
}

// check for movement (scrolling)
//if (KEY_DOWN(VK_UP))
//    {
//    if ((world_y-=4) < 0)
//       world_y = 0;
//
//    } // end if
//else
//if (KEY_DOWN(VK_DOWN))
//    {
//    if ((world_y+=4) >= 448)
//       world_y = 447;
//
//    } // end if


// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
//start_map_y = world_y/64; 
start_map_y = 0; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + 10 - 1;
end_map_y = start_map_y + 7 - 1;


// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;

// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
    for (index_x = start_map_x; index_x <= end_map_x; index_x++)
        {
        // set position to blit
        textures.x = texture_x;
        textures.y = texture_y;
        
        // set frame
        textures.curr_frame = Level[index_y][index_x];
		
		if (textures.curr_frame >= 12) textures.curr_frame = 0;

        // draw the texture
        Draw_BOB(&textures,lpddsback);

        // update texture position
        texture_x+=64;

        } // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += 64;

    } // end for map_y

Draw_Text_GDI("You Won The Level!",screen_width/2 - 70,screen_height/2 - 20 - 20, RGB(0,255,0),lpddsback);
Draw_Text_GDI("Press S to Continue",screen_width/2 - 70,screen_height/2 + 4 - 20, RGB(0,255,0),lpddsback);
//Draw_Text_GDI("Press ESC to Exit (lolnub)",screen_width/2 - 70,screen_height/2 + 28 - 20, RGB(0,255,0),lpddsback);




// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(15);

// return success
return(1);
}







///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

static int left_mouse_released = 0;

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y;

int world_x_bound;

int world_mouse_x, world_mouse_y; // world mouse positions

int offset_x, offset_y;       // pixel offsets within cell

int temp_tile;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

world_x_bound = (Level_Size - 10) * 64;

Player_Input (&Obj_List[PLAYER_BOB]);
Update_Camera(&Obj_List[PLAYER_BOB]);

// check for movement (scrolling)
//if (KEY_DOWN(VK_RIGHT))
//    {
//    if ((world_x+=4) >= world_x_bound)
//       world_x = world_x_bound - 1;
//
//	//if (zombie.curr_animation != ANIM_RIGHT)
// //     Set_Animation_BOB(&zombie,ANIM_RIGHT);
//
//    } // end if
//else
//if (KEY_DOWN(VK_LEFT))
//    {
//    if ((world_x-=4) < 0)
//       world_x = 0;
//
//	//if (zombie.curr_animation != ANIM_LEFT)
// //     Set_Animation_BOB(&zombie,ANIM_LEFT);
//    } // end if

// no up and down in this game!
//if (KEY_DOWN(VK_UP))
//    {
//    if ((world_y-=4) < 0)
//       world_y = 0;
//
//    } // end if
//else
//if (KEY_DOWN(VK_DOWN))
//    {
//    if ((world_y+=4) >= 448)
//       world_y = 447;
//
//    } // end if

// get the input from the mouse
lpdimouse->GetDeviceState(sizeof(DIMOUSESTATE), (LPVOID)&mouse_state);

// move the mouse cursor
mouse_x +=(mouse_state.lX);
mouse_y +=(mouse_state.lY);

// test bounds

// first x boundaries
if (mouse_x >= screen_width)
   mouse_x = screen_width-1;
else
if (mouse_x < 0)
   mouse_x = 0;

// now the y boundaries
if (mouse_y >= screen_height)
   mouse_y= screen_height-1;
else
if (mouse_y < 0)
   mouse_y = 0;

world_mouse_x = world_x + mouse_x;
//world_mouse_y = world_y + mouse_y;
world_mouse_y = mouse_y;

// compute grid coor of mouse curser
mouse_map_x = world_mouse_x/64;
mouse_map_y = world_mouse_y/64;

if (mouse_map_y >= 7) mouse_map_y = 6;

// if left mouse button is pressed, cycle through tile options
//if (mouse_state.rgbButtons[0] && left_mouse_released == 0)
//{
//	left_mouse_released = 1;
//	if (Level[mouse_map_y][mouse_map_x] == 11)
//		Level[mouse_map_y][mouse_map_x] = 0;
//	else if (Level[mouse_map_y][mouse_map_x] <=10)
//		Level[mouse_map_y][mouse_map_x]++;
//
//}
//else if (!mouse_state.rgbButtons[0]) left_mouse_released = 0;

// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
//start_map_y = world_y/64; 
start_map_y = 0; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + 10 - 1;
end_map_y = start_map_y + 7 - 1;


// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;

// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
    for (index_x = start_map_x; index_x <= end_map_x; index_x++)
        {
        // set position to blit
        textures.x = texture_x;
        textures.y = texture_y;
        
        // set frame
        textures.curr_frame = Level[index_y][index_x];
		
		if (textures.curr_frame >= 12) textures.curr_frame = 0;

        // draw the texture
        Draw_BOB(&textures,lpddsback);

        // update texture position
        texture_x+=64;

        } // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += 64;

    } // end for map_y

for (index = Num_Objects-1 ; index >= 0 ; index--)
{
	Update_BOB(&Obj_List[index]);
}

Draw_Bullets();
Calc_Bullets();
Take_Dmg (&Obj_List[PLAYER_BOB]);

// Draw mouse cursur.
//Draw_Rectangle (mouse_x-2, mouse_y-2, mouse_x+2, mouse_y+2, RGB(255,255,255),lpddsback);
//Draw_Rectangle (mouse_x-1, mouse_y-1, mouse_x+1, mouse_y+1, RGB(0,0,0),lpddsback);

// draw some info
//Draw_Text_GDI("USE ARROW KEYS TO MOVE, <ESC> to Exit.",8,8,RGB(255,255,255),lpddsback);

//sprintf(buffer,"World Position = [%d, %d]     Mouse Position = [%d, %d]", world_x, world_y, world_mouse_x, world_mouse_y);
//Draw_Text_GDI(buffer,8,screen_height - 32 - 24,RGB(0,255,0),lpddsback);
//sprintf(buffer,"x_bound: %d", world_x_bound);
//Draw_Text_GDI(buffer,8,screen_height - 24,RGB(0,255,0),lpddsback);
//
//sprintf (buffer, "var_jump: %f", var_jump);
//Draw_Text_GDI(buffer,8,screen_height - 32 - 48,RGB(0,255,0),lpddsback);

sprintf (buffer, "HEALTH: %d", Player_Life);
Draw_Text_GDI(buffer,8,screen_height - 20, RGB(0,255,0),lpddsback);

sprintf (buffer, "LIVES: %d", Player_Lives);
Draw_Text_GDI(buffer,screen_width - 70,screen_height - 20, RGB(0,255,0),lpddsback);

if ((Player_Life <= 0) ||
	(Obj_List[PLAYER_BOB].y >= screen_height))
{
	DSound_Play(sound_ids[DIE]);
	Player_Lives--;
	Player_Life = 100;

	Revive_Monsters();

	Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_X] = checkpoint_x;
	Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_Y] = checkpoint_y;

	world_x = Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_X] - SCROLL_LEFT;

	if (world_x < 0) world_x = 0;

	memset (Bullet_List, 0, sizeof (BULLETS) * MAX_BULLETS);

	if (Player_Lives < 0)
	{
		Player_Lives = 3;
		GAME_MODE = MENU;
		Unload_Level();
		Load_Level("menu.txt");
		return 0;
	}
}


if (Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_X] >= win_pos)
{
	GAME_MODE = MENU;
	Unload_Level();
	Load_Level("menu.txt");
	if (current_level == 4)
	{
		GAME_MODE = MENU;
		return 0;
	}
		
	//current_level++;
	sprintf (Next_Level, "level%d.txt", current_level);
	return 0;
}


// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(15);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////
// Player input
int Player_Input(BOB *pBob)
{
	static int left_key = 0;
	static int right_key = 0;
	//static int jump_key = 0;
	static int fire_key = 0;
	static int speed = 0;
	//static float var_jump = 0;
	static DWORD LeftClock = -1;
	static DWORD RightClock = -1;
	int anim_speed = 0;

	if (KEY_DOWN(VK_LEFT) && KEY_UP(VK_RIGHT) && left_key == 0)
	{
		//left command

		// uncomment to only allow 1 action per button press
		// (no holding button for continuous action).
		//left_key = 1;

		if (LeftClock == -1)
		{
			speed = CRAWL_SPEED;
			LeftClock = Get_Clock();
		}

		if ((Get_Clock() - LeftClock) > 4*WAIT_SPEED) speed = RUN_SPEED;
		else if ((Get_Clock() - LeftClock) > WAIT_SPEED) speed = WALK_SPEED;

		if (pBob->varsF[FORCE_X] >= -speed)
			pBob->varsF[FORCE_X]-=pBob->varsF[COF];

		switch (speed)
		{
		case CRAWL_SPEED:
			anim_speed = 20;
			break;
		case WALK_SPEED:
			anim_speed = 10;
			break;
		case RUN_SPEED:
			anim_speed = 5;
			break;
		default:
			break;
		}

		Set_Anim_Speed_BOB(pBob, anim_speed);

		if (pBob->curr_animation != ANIM_LEFT)
		{
			Set_Animation_BOB(pBob, ANIM_LEFT);
			pBob->anim_counter = pBob->anim_count_max;
		}

		Animate_BOB(pBob);
	}
	else if (KEY_UP(VK_LEFT))
	{
		LeftClock = -1;
		speed = CRAWL_SPEED;
		left_key = 0;
	}

	if (KEY_DOWN(VK_RIGHT) && KEY_UP(VK_LEFT) && right_key == 0)
	{
		//right
		// uncomment to only allow 1 action per button press
		// (no holding button for continuous action).
		//right_key = 1;

		if (RightClock == -1) 
		{
			speed = CRAWL_SPEED;
			RightClock = Get_Clock();
		}

		if ((Get_Clock() - RightClock) > 4*WAIT_SPEED) speed = RUN_SPEED;
		else if ((Get_Clock() - RightClock) > WAIT_SPEED) speed = WALK_SPEED;

		if (pBob->varsF[FORCE_X] <= speed)
			pBob->varsF[FORCE_X]+=pBob->varsF[COF];

		switch (speed)
		{
		case CRAWL_SPEED:
			anim_speed = 20;
			break;
		case WALK_SPEED:
			anim_speed = 10;
			break;
		case RUN_SPEED:
			anim_speed = 5;
			break;
		default:
			break;
		}

		Set_Anim_Speed_BOB(pBob, anim_speed);

		if (pBob->curr_animation != ANIM_RIGHT)
		{
			Set_Animation_BOB(pBob, ANIM_RIGHT);
			pBob->anim_counter = pBob->anim_count_max;
		}

		Animate_BOB(pBob);
	}
	else if (KEY_UP(VK_RIGHT))
	{
		RightClock = -1;
		speed = CRAWL_SPEED;
		right_key = 0;
	}

	



	if ((KEY_UP(VK_LEFT) && KEY_UP(VK_RIGHT) && (!pBob->varsI[AIR])) || 
		(KEY_DOWN(VK_LEFT) && KEY_DOWN(VK_RIGHT) && (!pBob->varsI[AIR])))
	{
		if (pBob->varsF[FORCE_X] > 0)
			pBob->varsF[FORCE_X]-=pBob->varsF[COF];
		else 
			pBob->varsF[FORCE_X]+=pBob->varsF[COF];

		if (abs(pBob->varsF[FORCE_X]) <= pBob->varsF[COF])
			pBob->varsF[FORCE_X] = 0;

		LeftClock = -1;
		RightClock = -1;
		speed = CRAWL_SPEED;
	}


	if (KEY_DOWN(VK_SPACE) &&  jump_key == 0)
	{
		//jump_key = 1;
		//jump
		if (var_jump == 0)
		{
			// first get unstuck from the ground
			pBob->varsI[OBJ_WORLD_Y]-=3;
			var_jump += JUMP_VEL;
		}
		else if (var_jump < JUMP_HEIGHT && var_jump > 0)
		{
			pBob->varsI[OBJ_WORLD_Y]-=JUMP_VEL;
			// keep setting this to 0 so gravity doesnt build up
			// and cause player to drop like a rock.
			pBob->varsF[FORCE_Y] = 0;
			var_jump += JUMP_VEL;
		}
		
		if (var_jump >= JUMP_HEIGHT)
		{
			pBob->varsF[FORCE_Y] = -JUMP_VEL+1;
			// this jump is finished. no further calculations
			// until we hit the ground. Let gravity do the rest.
			var_jump = -1;
		}


	}
	else if (KEY_UP(VK_SPACE) && pBob->varsI[AIR]) 
	{
		// player released jump key while still in the air.
		jump_key = 1;
		
		if (var_jump > 0)
		{
			pBob->varsF[FORCE_Y] = -JUMP_VEL+1;
			// this jump is finished. no further calculations
			// until we hit the ground. Let gravity do the rest.
			var_jump = -1;
		}
	}
	else if (KEY_UP(VK_SPACE) && (!pBob->varsI[AIR])) 
	{
		jump_key = 0;
		var_jump = 0;
	}





	if (KEY_DOWN(VK_CONTROL) && fire_key <= 0)
	{
		fire_key = PLAYER_COOL;
		//fire

		DSound_Play(sound_ids[SHOTGUN]);

		Fire_Weapon();

	}
	else
	{
		if (fire_key > 0)
			fire_key--;
	}








	return 1;
}

//////////////////////////////////////////////////////////
// checks and sees if file is an actual file.
// creates the file otherwise. If nothing is in the file
// it'll fill it with an empty level.
int Prep_File (char *Level_Name)
{
	FILE *pfile;
	char size[32];

	pfile = fopen(Level_Name, "r");

	if (pfile)
	{
		// for now just assume it has valid data.
		// no need to worry about it being otherwise for scope
		// of this project.
		fclose(pfile);
		return 1;
	}
	else
	{
		pfile = fopen(Level_Name, "w");
		fwrite("30",1,2,pfile);
		fwrite("\n",1,1,pfile);
		for (int i = 0 ; i < 7 ; i++)
		{
			for(int j = 0 ; j < 30 ; j++)
			{
				fwrite("0",1,1,pfile);
			}
			fwrite("\n",1,1,pfile);
		}

		fclose(pfile);
	}

	return 1;
}


//////////////////////////////////////////////////////////
// loads level from .txt file
int Load_Level (char *Level_Name)
{
	FILE *file_handle;
	char pt[1];
	int result;
	int isize = 0;
	char size[32];

	file_handle = fopen(Level_Name, "r");
	if (file_handle == NULL)
		return 0;

	fgets (size, sizeof(size), file_handle);

	isize = atoi(size);

	while (isize > Level_Size) Expand_Level();

	for (int i = 0 ; i < 7 ; i++)
	{
		for (int j = 0 ; j < isize ; j++)
		{
			result = fgetc(file_handle);
			result = result - '0';

			if (result < 0 || result >=12) 
			{
				Level[i][j] = 0;

				if (result >= OBJ_START)
					Add_Object(result, j, i);
			}
			else Level[i][j] = result;
		}
		// read one more for the '\n'
		fgetc(file_handle);
	}

	fclose(file_handle);

	return 0;
}

//////////////////////////////////////////////////////////////////
// Unload_Level
int Unload_Level()
{
	for (int i = 0 ; i < Num_Objects ; i++)
	{
		Destroy_BOB(&Obj_List[i]);
	}

	Num_Objects = 0;

	world_x = 0;
	world_y = 0;

	memset (Bullet_List, 0, sizeof(BULLETS) * MAX_BULLETS);

	return 1;
}



//////////////////////////////////////////////////////////////////
// saves level to .txt files
int Save_Level (char *Level_Name)
{
	FILE *file_handle;
	char pt[1];
	char size[32];
	int result;

	file_handle = fopen(Level_Name, "w");
	if (file_handle == NULL)
		return 0;

	itoa(Level_Size, size, 10);

	fwrite (size, 1, strlen(size), file_handle);
	fwrite ("\n", 1, 1, file_handle);

	for (int i = 0 ; i < 7 ; i++)
	{
		for (int j = 0 ; j < Level_Size ; j++)
		{
			pt[0] = Level[i][j] + '0';
			result = fwrite(pt, 1, 1, file_handle);
			if (result == -1)
			{
				return 0;
			}

		}

		fwrite("\n", 1, 1, file_handle);
	}

	fclose(file_handle);

	return 0;
}

//////////////////////////////////////////////////////////////////
// Expand_Level function adds 30 tiles to the current level.
int Expand_Level()
{
	int test;

	for (int i = 0 ; i < 7 ; i++)
	{
		Level[i] = (int*)realloc (Level[i], sizeof (*Level[i]) * (Level_Size + 30));

		if (Level[i] == 0) return (0);

		memset (&Level[i][Level_Size], 0 , sizeof(*Level[i]) * 30);
	}

	Level_Size = Level_Size + 30;

	return (1);
}

//////////////////////////////////////////////////////////////////
// Add Object
int Add_Object(int MobType, int worldpos_x, int worldpos_y)
{
	int pixpos_x, pixpos_y;
	int index;         // looping var
	char filename[80]; // used to build up files names


	if (Level[worldpos_y][worldpos_x] != 0)
	{
		// there's something here already, cant place object here!
		return 1;
	}

	Level[worldpos_y][worldpos_x] = MobType;

	Obj_List = (BOB*)realloc(Obj_List, (Num_Objects + 1) * sizeof(BOB));

	memset (&Obj_List[Num_Objects], 0, sizeof(BOB));

	switch (MobType)
	{
	case OBJ_START:
		// create the texture bob
		if (!Create_BOB(&Obj_List[Num_Objects],0,0,72,80,NUM_ZOMBIE_FRAMES, 
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
			return 0;

		// load the frames in 2 directions, 4 frames each
		// each set of frames has a walk and a fire, frame sets
		// are loaded in counter clockwise order looking down
		// from a birds eys view or the x-z plane
		for (int direction = 0; direction < 2; direction++)
		{
			// build up file name
			sprintf(filename,"pal_Hero0%d.bmp",direction+1);

			// load in new bitmap file
			Load_Bitmap_File(&bitmap8bit,filename);
			
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  
			
			// unload the bitmap file
			Unload_Bitmap_File(&bitmap8bit);
			
			// set the animation sequences for skelaton
			Load_Animation_BOB(&Obj_List[Num_Objects],direction,4,(int*)ply_anims[direction]);

		} // end for direction

		Obj_List[Num_Objects].varsF[FORCE_X] = 0;
		Obj_List[Num_Objects].varsF[FORCE_Y]  = 0;

		Set_Animation_BOB(&Obj_List[Num_Objects], ANIM_RIGHT);
		Set_Anim_Speed_BOB(&Obj_List[Num_Objects], 5);

		pixpos_x = worldpos_x * 64;
		pixpos_y = worldpos_y * 64;

		if (Obj_List[Num_Objects].height > 64)
		{
			pixpos_y = pixpos_y - (Obj_List[Num_Objects].height - 64);
		}

		//Set_Pos_BOB(&Obj_List[Num_Objects], pixpos_x, pixpos_y);
		Obj_List[Num_Objects].varsI[OBJ_WORLD_X] = pixpos_x;
		Obj_List[Num_Objects].varsI[OBJ_WORLD_Y] = pixpos_y;

		Obj_List[Num_Objects].varsI[OBJ_TYPE] = MobType;
		Obj_List[Num_Objects].varsI[BOB_X_NEAR] = P_ELBOW_ROOM;
		Obj_List[Num_Objects].varsI[BOB_X_FAR] = Obj_List[Num_Objects].width - P_ELBOW_ROOM;

		checkpoint_x = Obj_List[Num_Objects].varsI[OBJ_WORLD_X];
		checkpoint_y = Obj_List[Num_Objects].varsI[OBJ_WORLD_Y];

		PLAYER_BOB = Num_Objects;

		Num_Objects++;
		break;

	case OBJ_ZOMBIE:
		// create the texture bob
		if (!Create_BOB(&Obj_List[Num_Objects],0,0,72,80,NUM_ZOMBIE_FRAMES, 
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
			return 0;

		// load the frames in 2 directions, 4 frames each
		// each set of frames has a walk and a fire, frame sets
		// are loaded in counter clockwise order looking down
		// from a birds eys view or the x-z plane
		for (int direction = 0; direction < 2; direction++)
		{
			// build up file name
			sprintf(filename,"pal_Dedsp0%d.bmp",direction+1);

			// load in new bitmap file
			Load_Bitmap_File(&bitmap8bit,filename);
			
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,0+direction*5,0,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,1+direction*5,1,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,2+direction*5,2,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,3+direction*5,0,1,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,4+direction*5,2,1,BITMAP_EXTRACT_MODE_CELL);  
			
			// unload the bitmap file
			Unload_Bitmap_File(&bitmap8bit);
			
			// set the animation sequences for skelaton
			Load_Animation_BOB(&Obj_List[Num_Objects],direction,4,(int*)zom_anims[direction]);

		} // end for direction

		Obj_List[Num_Objects].varsF[FORCE_X] = 0;
		Obj_List[Num_Objects].varsF[FORCE_Y]  = 0;

		Set_Animation_BOB(&Obj_List[Num_Objects], ANIM_RIGHT);
		Set_Anim_Speed_BOB(&Obj_List[Num_Objects], 32);
		Obj_List[Num_Objects].anim_counter = Obj_List[Num_Objects].anim_count_max;

		pixpos_x = worldpos_x * 64;
		pixpos_y = worldpos_y * 64;

		if (Obj_List[Num_Objects].height > 64)
		{
			pixpos_y = pixpos_y - (Obj_List[Num_Objects].height - 64);
		}

		//Set_Pos_BOB(&Obj_List[Num_Objects], pixpos_x, pixpos_y);
		Obj_List[Num_Objects].varsI[OBJ_WORLD_X] = pixpos_x;
		Obj_List[Num_Objects].varsI[OBJ_WORLD_Y] = pixpos_y;
		Obj_List[Num_Objects].y = Obj_List[Num_Objects].varsI[OBJ_WORLD_Y] - world_y;

		Obj_List[Num_Objects].varsI[OBJ_TYPE] = MobType;
		Obj_List[Num_Objects].varsI[NPC_BEHAV] = -1;
		Obj_List[Num_Objects].varsI[NPC_DUR] = -1;
		Obj_List[Num_Objects].counter_2 = WEAPON_COOL - 5;

		Obj_List[Num_Objects].varsI[ZOM_LIFE] = ZOM_HEALTH;
		Obj_List[Num_Objects].varsI[DEATH_ANIM] = 0;

		Obj_List[Num_Objects].varsI[BOB_X_NEAR] = Z_ELBOW_ROOM;
		Obj_List[Num_Objects].varsI[BOB_X_FAR] = Obj_List[Num_Objects].width - Z_ELBOW_ROOM;

		Num_Objects++;
		break;

	case OBJ_DRONE:
		break;

	case OBJ_FINISH:
		win_pos = worldpos_x * 64;
		break;

	default:
		break;
	}

	return 0;
}


// Update where the world camera is
int Update_Camera(BOB *pBob)
{
	int world_x_bound = (Level_Size - 10) * 64;

	if (pBob->varsI[OBJ_WORLD_X] > world_x + SCROLL_RIGHT) 
	{
		world_x = pBob->varsI[OBJ_WORLD_X] - SCROLL_RIGHT;

		if (world_x >= world_x_bound)
			world_x = world_x_bound - 1;
	}

	if (pBob->varsI[OBJ_WORLD_X] < world_x + SCROLL_LEFT) 
	{
		world_x = pBob->varsI[OBJ_WORLD_X] - SCROLL_LEFT;

		if (world_x < 0)
			world_x = 0;
	}


	return 1;
}

// calculate everything for the bob
int Update_BOB(BOB *pBob)
{


	if ((pBob->varsI[OBJ_WORLD_X] >= world_x + screen_width) ||
		(pBob->varsI[OBJ_WORLD_X] <= world_x - pBob->width))
	{
		// object is offscreen, dont both calculating anything
		//pBob->varsF[FORCE_Y] = 0;
		//pBob->varsF[FORCE_X] = 0;
		return 0;
	}
	else
	{
		pBob->x = pBob->varsI[OBJ_WORLD_X] - world_x;
	}




	if ((pBob->varsI[OBJ_WORLD_Y] >= world_y + screen_height))
	{
		// object is offscreen, dont both calculating anything
		//pBob->varsF[FORCE_Y] = 0;
		//pBob->varsF[FORCE_X] = 0;
		return 0;
	}
	else
	{
		pBob->y = pBob->varsI[OBJ_WORLD_Y] - world_y;
	}

	
	if (pBob->varsI[OBJ_TYPE] == OBJ_ZOMBIE)
	{

		Zombie_Behavior(pBob);
	}



	if (pBob->varsI[OBJ_TYPE] == OBJ_START)
		Y_Collision (pBob);

	X_Collision (pBob);


	pBob->x+=pBob->varsF[FORCE_X];
	pBob->varsI[OBJ_WORLD_X]+=pBob->varsF[FORCE_X];

	pBob->y+=pBob->varsF[FORCE_Y];
	pBob->varsI[OBJ_WORLD_Y]+=pBob->varsF[FORCE_Y];

	//pBob->x= mouse_x;
	//pBob->y= mouse_y;

	if (pBob->varsI[OBJ_TYPE] == OBJ_ZOMBIE)
	{
		if (pBob->varsI[NPC_BEHAV] == ZOM_AGGRO && pBob->varsI[ZOM_LIFE] > 0)
			pBob->curr_frame = AGRO_FRAME(pBob->curr_animation);
		else if (pBob->varsI[ZOM_LIFE] > 0)
			Animate_BOB(pBob);			
	}

	if (pBob->varsI[AIR] && pBob->varsI[OBJ_TYPE] == OBJ_START)
		pBob->curr_frame = JUMP_FRAME(pBob->curr_animation);

	//pBob->x = mouse_x;
	//pBob->y = mouse_y;
	Draw_BOB(pBob,lpddsback);

	//Draw_Rectangle (pBob->x+24, pBob->y, 
	//			pBob->x+pBob->width-24,pBob->y+pBob->height, 
	//				RGB(255,255,255), lpddsback);

	return 0;
}































/////////////////////////////////////////
// Y_collision
int Y_Collision(BOB *pBob)
{
	int remainder = 0;
	int temp_x = 0;

	DDraw_Lock_Back_Surface();

	if (Color_Scan (pBob->x+34, pBob->y, 
				pBob->x+pBob->width-34,pBob->y+10, 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
	{
		// we hit our head on something, go down
		pBob->varsF[FORCE_Y] = 0;
		pBob->varsF[COF] = AIR_ACC;
		pBob->varsI[AIR] = true;

		pBob->varsI[OBJ_WORLD_Y] += JUMP_VEL;
		jump_key = 1;
		var_jump = -1;

	}

	if (Color_Scan (pBob->x+24, pBob->y+20, 
				pBob->x+pBob->width-24,pBob->y+pBob->height, 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
	{
		//Draw_Text_GDI("Color_Scan = TRUE",8,screen_height - 64 - 24,RGB(0,255,0),lpddsback);
		
		//if (pBob->varsF[FORCE_Y] > 0)
			pBob->varsF[FORCE_Y] = 0;
			pBob->varsF[COF] = GROUND_ACC;
			pBob->varsI[AIR] = false;

			if (pBob->curr_frame == JUMP_FRAME(pBob->curr_animation))
				pBob->curr_frame = LAND_FRAME(pBob->curr_animation);
	}
	else
	{
		//Draw_Text_GDI("Color_Scan = FALSE",8,screen_height - 64 - 24,RGB(0,255,0),lpddsback);

		pBob->varsF[FORCE_Y]+=GRAVITY;
		pBob->varsF[COF] = AIR_ACC;
		pBob->varsI[AIR] = true;

		if (Color_Scan (pBob->x+24, pBob->y + pBob->varsF[FORCE_Y] + 20, 
				pBob->x+pBob->width-24,pBob->y+pBob->height + pBob->varsF[FORCE_Y], 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
		{
			// sunk into something solid, need to find exact collision.
			
			remainder = pBob->y + pBob->height;
			temp_x = pBob->x;
			
			while ((!Color_Scan(temp_x+24, remainder, temp_x+48, remainder, 1, 255, back_buffer, back_lpitch)) &&
				   (remainder <= (screen_height+pBob->height)))
				remainder++;
			
			pBob->y = remainder - pBob->height + 1; // +1 so character sits withtin floor a little.
			pBob->varsI[OBJ_WORLD_Y] = remainder - pBob->height + 1; // +1 so character sits withtin floor a little.
			pBob->varsF[FORCE_Y] = 0;
			pBob->varsF[COF] = GROUND_ACC;
			pBob->varsI[AIR] = false;

			if (pBob->curr_frame == JUMP_FRAME(pBob->curr_animation))
			pBob->curr_frame = LAND_FRAME(pBob->curr_animation);
		}
	}

	
	DDraw_Unlock_Back_Surface();

	return 1;
}


/////////////////////////////////////////
// X_collision
int X_Collision(BOB *pBob)
{
	int remainder = 0;
	int temp_x = 0;
	int direction = 0;
	int blocked = 0;

	DDraw_Lock_Back_Surface();

	if (pBob->varsF[FORCE_X] > 0)
	{
		remainder = pBob->x + pBob->varsI[BOB_X_FAR];
		temp_x = pBob->varsI[BOB_X_FAR];
		direction = 1;
	}
	else if (pBob->varsF[FORCE_X] < 0)
	{
		remainder = pBob->x + pBob->varsI[BOB_X_NEAR];
		temp_x = pBob->varsI[BOB_X_NEAR];
		direction = -1;
	}
	else if (pBob->varsF[FORCE_X] == 0)
	{
		remainder = pBob->x + pBob->width / 2;
	}


	if (Color_Scan (remainder, pBob->y + 10, 
				remainder,pBob->y+pBob->height - P_FEET_ROOM, 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
	{
		// hopefully fixes some rounding issues.
		if (pBob->varsF[FORCE_X] > 0) pBob->varsF[FORCE_X]--;

		pBob->x-=pBob->varsF[FORCE_X];
		pBob->varsI[OBJ_WORLD_X]-=pBob->varsF[FORCE_X];
		pBob->varsF[FORCE_X] = 0;

		blocked = 1;

			//if (pBob->curr_frame == JUMP_FRAME(pBob->curr_animation))
			//	pBob->curr_frame = LAND_FRAME(pBob->curr_animation);
	}
	//else
	//{
	//	//Draw_Text_GDI("Color_Scan = FALSE",8,screen_height - 64 - 24,RGB(0,255,0),lpddsback);

	//	if (Color_Scan (pBob->x+P_ELBOW_ROOM + pBob->varsF[FORCE_X], pBob->y, 
	//			pBob->x+pBob->width-P_ELBOW_ROOM + pBob->varsF[FORCE_X],pBob->y+pBob->height - P_FEET_ROOM, 
	//			1, 255, // hoping this is black color
	//			back_buffer,back_lpitch))
	//	{
	//		// sunk into something solid, need to find exact collision.
	//		
	//		if (pBob->varsF[FORCE_X] > 0)
	//		{
	//			remainder = pBob->x + pBob->width - P_ELBOW_ROOM;
	//			temp_x = pBob->width - P_ELBOW_ROOM;
	//			direction = 1;
	//		}
	//		else if (pBob->varsF[FORCE_X] < 0)
	//		{
	//			remainder = pBob->x + P_ELBOW_ROOM;
	//			temp_x = 24;
	//			direction = -1;
	//		}

	//		
	//		while ((!Color_Scan(remainder, pBob->y, remainder, pBob->y + pBob->height - P_FEET_ROOM, 1, 255, back_buffer, back_lpitch)) &&
	//			      (remainder <= (screen_width+pBob->width))   &&   (remainder >= (-pBob->width))          )
	//			remainder+=direction;
	//		
	//		pBob->x = remainder - temp_x; // +1 so character sits withtin floor a little.
	//		pBob->varsI[OBJ_WORLD_X] = remainder - temp_x + world_x; // +1 so character sits withtin floor a little.
	//		pBob->varsF[FORCE_X] = 0;

	//		//if (pBob->curr_frame == JUMP_FRAME(pBob->curr_animation))
	//		//pBob->curr_frame = LAND_FRAME(pBob->curr_animation);
	//	}
	//}

	// special test for zombie
	if (pBob->varsI[OBJ_TYPE] == OBJ_ZOMBIE && blocked == 0)
	{
		if (!Color_Scan (remainder, pBob->y+pBob->height + P_FEET_ROOM, 
				remainder,pBob->y+pBob->height + 64 - P_FEET_ROOM, 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
		{
			blocked = 1;
		}

		if (remainder <= 0 || remainder >= screen_width) blocked = 1;
	}

	if (pBob->varsI[OBJ_TYPE] == OBJ_ZOMBIE && blocked == 1)
		pBob->varsI[NPC_BEHAV] = ZOM_STAND;

	//sprintf (buffer, "remainder: %d", remainder);
	//Draw_Text_GDI("WRYYYYYYY",8,screen_height - 64 - 72,RGB(0,255,0),lpddsback);

	DDraw_Unlock_Back_Surface();

	return 1;
}














/////////////////////////////////////////
// Zombie_Behavior: Calculates everything the cake zombies do
//
int Zombie_Behavior (BOB *pBob)
{
	if ((pBob->varsI[ZOM_LIFE] <= 0) && (pBob->varsI[DEATH_ANIM] < 80))
	{
		if (pBob->varsI[DEATH_ANIM] == 0)
			DSound_Play(sound_ids[ZOM_DIE]);	

		if (pBob->varsI[DEATH_ANIM]%2)
			pBob->curr_frame = DEAD_FRAME(pBob->curr_animation);						
		else 
			pBob->curr_frame = STND_FRAME(pBob->curr_animation);


		pBob->varsF[FORCE_X] = 0;

		//sprintf (buffer, "DEATH_ANIM: %d",pBob->varsI[DEATH_ANIM]); 
		//Draw_Text_GDI(buffer,8,screen_height - 40, RGB(0,255,0),lpddsback);

		pBob->varsI[DEATH_ANIM]++;
		return 1;
	}
	else if (pBob->varsI[ZOM_LIFE] <= 0 && pBob->varsI[DEATH_ANIM] >= 80)
	{
		//sprintf (buffer, "DEATH_ANIM: %d",pBob->varsI[DEATH_ANIM]); 
		//Draw_Text_GDI(buffer,8,screen_height - 40, RGB(0,255,0),lpddsback);
		//Draw_Text_GDI("OMFGIN",8,screen_height - 40, RGB(0,255,0),lpddsback);
		return 1;
	}

	//sprintf (buffer, "DEATH_ANIM: %d",pBob->varsI[DEATH_ANIM]); 
	//	Draw_Text_GDI(buffer,8,screen_height - 40, RGB(0,255,0),lpddsback);

	//Draw_Text_GDI("OMFGIN",8,screen_height - 40, RGB(0,255,0),lpddsback);

	// if player is not within aggro range, then do something boring
	if (!(abs(Obj_List[PLAYER_BOB].x - pBob->x) < AGGRO_RANGE))
	{

		// which random behavior will the NPC do
		if (pBob->varsI[NPC_BEHAV] == -1) 
		{
			pBob->varsI[NPC_BEHAV] = RAND_RANGE(ZOM_STAND, ZOM_WALK);

			if (pBob->varsI[NPC_BEHAV] == ZOM_WALK)
				pBob->varsI[NPC_DIR] = RAND_RANGE(ANIM_RIGHT, ANIM_LEFT);
		}


		// how long will they do it
		if (pBob->varsI[NPC_DUR] == -1)
		{
			pBob->varsI[NPC_DUR] = RAND_RANGE(MIN_DUR, MAX_DUR);
			pBob->counter_1 = 0;
		}

		switch (pBob->varsI[NPC_BEHAV])
		{
		case ZOM_STAND:
			pBob->varsF[FORCE_X] = 0;
			break;

		case ZOM_WALK:
			if (pBob->varsI[NPC_DIR] == ANIM_RIGHT) 
				pBob->varsF[FORCE_X] = ZOM_WALK_SPD;
			else
				pBob->varsF[FORCE_X] = -ZOM_WALK_SPD;

			if (pBob->curr_animation != pBob->varsI[NPC_DIR])
			{
				Set_Animation_BOB(pBob, pBob->varsI[NPC_DIR]);
				pBob->anim_counter = pBob->anim_count_max;
			}
			break;

		default:
			pBob->varsF[FORCE_X] = 0;
			break;
		}

		pBob->counter_1++;
		if (pBob->counter_1 >= pBob->varsI[NPC_DUR])
		{
			pBob->varsI[NPC_BEHAV] = -1;
			pBob->varsI[NPC_DUR] = -1;
			pBob->counter_1 = 0;
		}
	}
	else 
	{
		pBob->varsF[FORCE_X] = 0;

		pBob->varsI[NPC_BEHAV] = ZOM_AGGRO;
		// Attack player.
		if ((Obj_List[PLAYER_BOB].x - pBob->x) >= 0)
			Set_Animation_BOB(pBob, ANIM_RIGHT);
		else
			Set_Animation_BOB(pBob, ANIM_LEFT);

		pBob->counter_2++;
		if (pBob->counter_2 >= WEAPON_COOL)
		{
			pBob->counter_2 = 0;
			Add_Bullet(pBob, &Obj_List[PLAYER_BOB]);
			DSound_Play(sound_ids[ENEMY_GUN]);
		}

	}

	return 1;
}



























int Add_Bullet(BOB* source, BOB* target)
{
	float x_diff;
	float y_diff;
	int x_inc = 1;
	int y_inc = 1;
	int x0, x1;
	int y0, y1;
	int direction_off;

	if (current_bullet >= MAX_BULLETS)
		current_bullet = 0;

	Bullet_List[current_bullet].active = 1;

	x1 = target->varsI[OBJ_WORLD_X] + (target->width/2);
	y1 = target->varsI[OBJ_WORLD_Y] + (target->height/2);

	if (source->curr_animation == ANIM_LEFT) direction_off = 5;
	else direction_off = source->width - 5;

	x0 = source->varsI[OBJ_WORLD_X] + direction_off;
	y0 = source->varsI[OBJ_WORLD_Y] + 30;

	x_diff = x1 - x0;
	y_diff = y1 - y0;

	Bullet_List[current_bullet].world_x = x0;
	Bullet_List[current_bullet].world_y = y0;
	//Bullet_List[current_bullet].b = - (Bullet_List[current_bullet].slope * Bullet_List[current_bullet].world_x);
	//Bullet_List[current_bullet].b = source->varsI[OBJ_WORLD_Y];


	if (x_diff < 0)
	{
		x_inc = -1;
		x_diff = x_diff * -1;
	}

	if (y_diff < 0)
	{
		y_inc = -1;
		y_diff = y_diff * -1;
	}

	
	if (x_diff == 0) x_diff = 0.001;
	if (y_diff == 0) y_diff = 0.001;

	Bullet_List[current_bullet].vel_y = BULLET_VEL * (y_diff/(x_diff+y_diff));	
	Bullet_List[current_bullet].vel_x = BULLET_VEL * (x_diff/(y_diff+x_diff));

	Bullet_List[current_bullet].vel_x = Bullet_List[current_bullet].vel_x * x_inc;
	Bullet_List[current_bullet].vel_y = Bullet_List[current_bullet].vel_y * y_inc;

	current_bullet++;
	
	return 1;
}






















int Draw_Bullets()
{
	int i;

	for (i = 0 ; i < MAX_BULLETS ; i++)
	{
		if (Bullet_List[i].active)
		{
			if (((Bullet_List[i].world_x >= world_x) &&
				(Bullet_List[i].world_x <= world_x+screen_width))
								
								&&
				
				((Bullet_List[i].world_y >= world_y) &&
				(Bullet_List[i].world_y <= world_y+screen_height)))
			{
				Bullet_List[i].screen_x = Bullet_List[i].world_x - world_x;
				Bullet_List[i].screen_y = Bullet_List[i].world_y - world_y;

				Draw_Rectangle (Bullet_List[i].screen_x-2, Bullet_List[i].screen_y-4, 
							Bullet_List[i].screen_x+2, Bullet_List[i].screen_y+4, 
							0,lpddsback);
				Draw_Rectangle (Bullet_List[i].screen_x-3, Bullet_List[i].screen_y-3, 
							Bullet_List[i].screen_x+3, Bullet_List[i].screen_y+3, 
							0,lpddsback);
				Draw_Rectangle (Bullet_List[i].screen_x-4, Bullet_List[i].screen_y-2, 
							Bullet_List[i].screen_x+4, Bullet_List[i].screen_y+2, 
							0,lpddsback);


				Draw_Rectangle (Bullet_List[i].screen_x-2, Bullet_List[i].screen_y-3, 
							Bullet_List[i].screen_x+2, Bullet_List[i].screen_y+3, 
							22,lpddsback);
				Draw_Rectangle (Bullet_List[i].screen_x-3, Bullet_List[i].screen_y-2, 
							Bullet_List[i].screen_x+3, Bullet_List[i].screen_y+2, 
							22,lpddsback);


				Draw_Rectangle (Bullet_List[i].screen_x-1, Bullet_List[i].screen_y-1, 
							Bullet_List[i].screen_x+1, Bullet_List[i].screen_y+1, 
							237,lpddsback);
			}

		}
	}

	return 1;
}












int Calc_Bullets()
{
	int i;

	for (i = 0 ; i < MAX_BULLETS ; i++)
	{
		if (Bullet_List[i].active)
		{
			if (((Bullet_List[i].world_x >= 0) &&
				(Bullet_List[i].world_x <= Level_Size*64))
								
								&&
				
				((Bullet_List[i].world_y >= 0) &&
				(Bullet_List[i].world_y <= screen_height)))
			{


			Bullet_List[i].world_x += Bullet_List[i].vel_x;
			Bullet_List[i].world_y += Bullet_List[i].vel_y;

			//sprintf(buffer,"slope: %f", Bullet_List[i].slope);
			//Draw_Text_GDI(buffer,8,screen_height - 32 - 72,RGB(0,255,0),lpddsback);
			}
			else
				Bullet_List[i].active = 0;

		}
	}


	return 1;
}














int Take_Dmg (BOB *pBob)
{

	int Bull_count;

	for (Bull_count = 0 ; Bull_count < MAX_BULLETS ; Bull_count++)
	{
		if (Bullet_List[Bull_count].active)
		{
			if ((pBob->varsI[OBJ_WORLD_X]+P_ELBOW_ROOM <= Bullet_List[Bull_count].world_x) &&
				(pBob->varsI[OBJ_WORLD_X]+pBob->width-P_ELBOW_ROOM >= Bullet_List[Bull_count].world_x) &&
				(pBob->varsI[OBJ_WORLD_Y]+P_FEET_ROOM <= Bullet_List[Bull_count].world_y) &&
				(pBob->varsI[OBJ_WORLD_Y]+pBob->height-P_FEET_ROOM >= Bullet_List[Bull_count].world_y))
			{
				Player_Life-=7;
				Bullet_List[Bull_count].active = 0;
				DSound_Play(sound_ids[HURT]);
			}
		}
	}

	return 1;
}
















int Revive_Monsters()
{
	int counter = 0;

	for (counter = 0 ; counter < Num_Objects ; counter++)
	{
		if (Obj_List[counter].varsI[OBJ_TYPE] == OBJ_ZOMBIE)
		{
			Obj_List[counter].varsI[ZOM_LIFE] = ZOM_HEALTH;
			Obj_List[counter].varsI[DEATH_ANIM] = 0;
		}
	}

	return 1;
}



int Fire_Weapon()
{
	int i;
	int diff = 0;
	int dmg;

	if (Obj_List[PLAYER_BOB].curr_animation == ANIM_RIGHT)
	{
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-4+36, 
	//			Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+2, Obj_List[PLAYER_BOB].y+4+36, 
	//			0,lpddsback);
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-3+36, 
	//			Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+3, Obj_List[PLAYER_BOB].y+3+36, 
	//			0,lpddsback);
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-2+36, 
	//			Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+4, Obj_List[PLAYER_BOB].y+2+36, 
	//			0,lpddsback);


	Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-6+36, 
				Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+4, Obj_List[PLAYER_BOB].y+6+36, 
				22,lpddsback);
	Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-4+36, 
				Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+6, Obj_List[PLAYER_BOB].y+4+36, 
				22,lpddsback);


	Draw_Rectangle (Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width, Obj_List[PLAYER_BOB].y-2+36, 
				Obj_List[PLAYER_BOB].x + Obj_List[PLAYER_BOB].width+2, Obj_List[PLAYER_BOB].y+2+36, 
				237,lpddsback);
	}
	else
	{
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x-2, Obj_List[PLAYER_BOB].y-4+36, 
	//			Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+4+36, 
	//			0,lpddsback);
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x-3, Obj_List[PLAYER_BOB].y-3+36, 
	//			Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+3+36, 
	//			0,lpddsback);
	//Draw_Rectangle (Obj_List[PLAYER_BOB].x-4, Obj_List[PLAYER_BOB].y-2+36, 
	//			Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+2+36, 
	//			0,lpddsback);


	Draw_Rectangle (Obj_List[PLAYER_BOB].x-4, Obj_List[PLAYER_BOB].y-6+36, 
				Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+6+36, 
				22,lpddsback);
	Draw_Rectangle (Obj_List[PLAYER_BOB].x-6, Obj_List[PLAYER_BOB].y-4+36, 
				Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+4+36, 
				22,lpddsback);


	Draw_Rectangle (Obj_List[PLAYER_BOB].x-2, Obj_List[PLAYER_BOB].y-2+36, 
				Obj_List[PLAYER_BOB].x, Obj_List[PLAYER_BOB].y+1+36, 
				237,lpddsback);
	}


	for (i = 0 ; i < Num_Objects ; i++)
	{
		if (Obj_List[i].varsI[OBJ_TYPE] == OBJ_ZOMBIE)
		{
			diff = Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_X] - Obj_List[i].varsI[OBJ_WORLD_X];
			
			if (Obj_List[PLAYER_BOB].curr_animation == ANIM_RIGHT)
			{
				if (diff < 0)
				{
					diff = abs(diff);
					dmg = PLAYER_POW - (diff/2);
				}
				else dmg = 0;
			}
			else
			{
				if (diff > 0)
				{
					diff = abs(diff);
					dmg = PLAYER_POW - (diff/2);
				}
				else dmg = 0;
			}

			if ((abs(Obj_List[PLAYER_BOB].varsI[OBJ_WORLD_Y] - Obj_List[i].varsI[OBJ_WORLD_Y]) < 40) &&
				(dmg > 0) && (Obj_List[i].varsI[ZOM_LIFE] > 0))
			{
				temp_dmg = dmg;
				Obj_List[i].varsI[ZOM_LIFE]-=dmg;
				DSound_Play(sound_ids[ZOM_DMG]);
			}
		}
		diff = 0;
	}

	return 1;
}