// Cake Zombies Level Editor.

#include "CakeZombies.h"

// DEFINES ////////////////////////////////////////////////

// defines for windows 
#define WINDOW_CLASS_NAME "WINCLASS1"

// PROTOTYPES //////////////////////////////////////////////

LRESULT CALLBACK WindowProc(HWND hwnd, 
						    UINT msg, 
                            WPARAM wparam, 
                            LPARAM lparam)
{
// this is the main message handler of the system
PAINTSTRUCT		ps;		// used in WM_PAINT
HDC				hdc;	// handle to a device context
char buffer[80];        // used to print strings
int swap;
int temp_mm_x, temp_mm_y;

// what is the message 
switch(msg)
	{	
	case WM_CREATE: 
        {
		// do initialization stuff here
        // return success
		return(0);
		} break;
   
	case WM_PAINT: 
		{
		// simply validate the window 
   	    hdc = BeginPaint(hwnd,&ps);	 
        
        // end painting
        EndPaint(hwnd,&ps);

        // return success
		return(0);
   		} break;

	case WM_DESTROY: 
		{

		// kill the application, this sends a WM_QUIT message 
		PostQuitMessage(0);

        // return success
		return(0);
		} break;

	//case WM_LBUTTONDOWN:
	//	// if left mouse button is pressed, cycle through tile options
	//	Level[mouse_map_y][mouse_map_x]++;
	//	if (Level[mouse_map_y][mouse_map_x] >= 11)
	//		Level[mouse_map_y][mouse_map_x] = 0;
	//	Game_Main();
	//	break;

	case WM_RBUTTONDOWN:
		drag_brush = Level[mouse_map_y][mouse_map_x];
		mouse_drag_x_start = mouse_map_x;
		mouse_drag_y_start = mouse_map_y;
		break;

	case WM_RBUTTONUP:
		temp_mm_x = mouse_map_x;
		temp_mm_y = mouse_map_y;

		if (mouse_drag_x_start > mouse_map_x)
		{
			swap = temp_mm_x;
			temp_mm_x = mouse_drag_x_start;
			mouse_drag_x_start = swap;
		}

		if (mouse_drag_y_start > mouse_map_y)
		{
			swap = temp_mm_y;
			temp_mm_y = mouse_drag_y_start;
			mouse_drag_y_start = swap;
		}

		for (int i = mouse_drag_x_start ; i <= temp_mm_x ; i++)
			for (int j = mouse_drag_y_start ; j <= temp_mm_y ; j++)
			{
				if ((Level[j][i] <= 11) && (drag_brush <= 11))
					Level[j][i] = drag_brush;
			}
		break;

	case WM_KEYDOWN:
		switch (wparam)
		{
		case 'e':
		case 'E':
			Expand_Level();
			break;

		case 's':
		case 'S':
			Save_Level(mapname);
			break;

		case '1':
			//Add_Object(OBJ_START, mouse_map_x, mouse_map_y);
			Level[mouse_map_y][mouse_map_x] = OBJ_START;
			break;

		case '2':
			//Add_Object(OBJ_ZOMBIE, mouse_map_x, mouse_map_y);
			Level[mouse_map_y][mouse_map_x] = OBJ_ZOMBIE;
			break;

		case '3':
			//Add_Object(OBJ_DRONE, mouse_map_x, mouse_map_y);
			Level[mouse_map_y][mouse_map_x] = OBJ_DRONE;
			break;

		case '4':
			//Add_Object(OBJ_FINISH, mouse_map_x, mouse_map_y);
			Level[mouse_map_y][mouse_map_x] = OBJ_FINISH;
			break;

		case '0':
			// could have some way of freeing the BOB,
			// but not necessary for what this program does.
			Level[mouse_map_y][mouse_map_x] = 0;
			break;

		default:
			break;
		}
		break;

	default:break;

    } // end switch

// process any messages that we didn't take care of 
return (DefWindowProc(hwnd, msg, wparam, lparam));

} // end WinProc

// WINMAIN ////////////////////////////////////////////////

int WINAPI WinMain(	HINSTANCE hinstance,
					HINSTANCE hprevinstance,
					LPSTR lpcmdline,
					int ncmdshow)
{

WNDCLASSEX winclass; // this will hold the class we create
HWND	   hwnd;	 // generic window handle
MSG		   msg;		 // generic message
HDC        hdc;      // graphics device context

// before doing ANYTHING we need to make sure we can open
// the level that's been passed.
strcpy (mapname, lpcmdline);

// if no file name is passed, nothing to do.
if (strlen(mapname) <= 0) return 0;

// make sure file is okay.
Prep_File (mapname);

// first fill in the window class stucture
winclass.cbSize         = sizeof(WNDCLASSEX);
winclass.style			= CS_DBLCLKS | CS_OWNDC | 
                          CS_HREDRAW | CS_VREDRAW;
winclass.lpfnWndProc	= WindowProc;
winclass.cbClsExtra		= 0;
winclass.cbWndExtra		= 0;
winclass.hInstance		= hinstance;
winclass.hIcon			= LoadIcon(NULL, IDI_APPLICATION);
winclass.hCursor		= LoadCursor(NULL, IDC_ARROW); 
winclass.hbrBackground	= (HBRUSH)GetStockObject(BLACK_BRUSH);
winclass.lpszMenuName	= NULL;
winclass.lpszClassName	= WINDOW_CLASS_NAME;
winclass.hIconSm        = LoadIcon(NULL, IDI_APPLICATION);

// save hinstance in global
main_instance = hinstance;

// register the window class
if (!RegisterClassEx(&winclass))
	return(0);

// create the window
if (!(hwnd = CreateWindowEx(NULL,                  // extended style
                            WINDOW_CLASS_NAME,     // class
						    "DirectDraw 8-Bit Smooth Scrolling Demo", // title
						    WS_POPUP | WS_VISIBLE,
					 	    0,0,	  // initial x,y
						    SCREEN_WIDTH,SCREEN_HEIGHT,  // initial width, height
						    NULL,	  // handle to parent 
						    NULL,	  // handle to menu
						    hinstance,// instance of this application
						    NULL)))	// extra creation parms
return(0);

// save main window handle
main_window_handle = hwnd;

// initialize game here
Game_Init();

// enter main event loop
while(TRUE)
	{
    // test if there is a message in queue, if so get it
	if (PeekMessage(&msg,NULL,0,0,PM_REMOVE))
	   { 
	   // test if this is a quit
       if (msg.message == WM_QUIT)
           break;
	
	   // translate any accelerator keys
	   TranslateMessage(&msg);

	   // send the message to the window proc
	   DispatchMessage(&msg);
	   } // end if
    
       // main game processing goes here
       Game_Main();
       
	} // end while

// closedown game here
Game_Shutdown();

// return to Windows like this
return(msg.wParam);

} // end WinMain

// GAME PROGRAMMING CONSOLE FUNCTIONS ////////////////

int Game_Init(void *parms,  int num_parms)
{
// this function is where you do all the initialization 
// for your game

int index;         // looping var
char filename[80]; // used to build up files names

// allocate memory of stage.
for (int i = 0 ; i < 7 ; i++)
{
	Level[i] = (int*)malloc (sizeof(*Level[i]) * 30);
	memset (Level[i], 0 , sizeof(*Level[i]) * 30);
}

if (Level == 0) return 0;

Level_Size = 30;


// initialize directdraw
DDraw_Init(SCREEN_WIDTH, SCREEN_HEIGHT, SCREEN_BPP, false);

// first create the direct input object
DirectInput8Create(main_instance,DIRECTINPUT_VERSION,IID_IDirectInput8, (void **)&lpdi,NULL);

// create a mouse device  /////////////////////////////////////
lpdi->CreateDevice(GUID_SysMouse, &lpdimouse, NULL);

// set data format
lpdimouse->SetDataFormat(&c_dfDIMouse);

// acquire the mouse
lpdimouse->Acquire();

/////////////////////////////////////////////////////////////////

// set the global mouse position
mouse_x = screen_width/2;
mouse_y = screen_height/2;

// load in texture maps
Load_Bitmap_File(&bitmap8bit, "scrolltextures.bmp");

// set the palette to background image palette
Set_Palette(bitmap8bit.palette);

// create the texture bob
if (!Create_BOB(&textures,0,0,64,64,NUM_TEXTURES, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_FRAME,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load each texture bitmap into the texture BOB object
for (index = 0; index < NUM_TEXTURES; index++)
    Load_Frame_BOB(&textures,&bitmap8bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
Unload_Bitmap_File(&bitmap8bit);

memset (&bitmap8bit, 0, sizeof(bitmap8bit));

// create the texture bob
if (!Create_BOB(&zombie,0,0,72,80,NUM_ZOMBIE_FRAMES, 
                BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
   return(0);

// load the frames in 2 directions, 4 frames each
// each set of frames has a walk and a fire, frame sets
// are loaded in counter clockwise order looking down
// from a birds eys view or the x-z plane
for (int direction = 0; direction < 2; direction++)
    { 
    // build up file name
    sprintf(filename,"pal_Dedsp0%d.bmp",direction+1);

    // load in new bitmap file
    Load_Bitmap_File(&bitmap8bit,filename);
 
    Load_Frame_BOB(&zombie,&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombie,&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombie,&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
    Load_Frame_BOB(&zombie,&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  

    // unload the bitmap file
    Unload_Bitmap_File(&bitmap8bit);

    // set the animation sequences for skelaton
    Load_Animation_BOB(&zombie,direction,4,(int*)zombie_anims[direction]);

    } // end for direction

// load each texture bitmap into the texture BOB object
//for (index = 0; index < NUM_ZOMBIE_FRAMES; index++)
//    Load_Frame_BOB(&zombie,&bitmap8bit,index,index%4,index/4,BITMAP_EXTRACT_MODE_CELL); 

// unload the texture map bitmap
//Unload_Bitmap_File(&bitmap8bit);

// set clipping rectangle to screen extents so mouse cursor
// doens't mess up at edges
RECT screen_rect = {0,0,screen_width,screen_height}; // 32 pixels at the bottom for controls

// notice at bottom of screen a blank rect, this would be for your
// control panel for example
lpddclipper = DDraw_Attach_Clipper(lpddsback,1,&screen_rect);

Load_Level (mapname);

zombie.varsF[FORCE_X] = 0;
zombie.varsF[FORCE_Y]  = 0;

Set_Animation_BOB(&zombie, ANIM_LEFT);
Set_Anim_Speed_BOB(&zombie, 32);
//Set_Vel_BOB(&zombie, 0,0);
Set_Pos_BOB(&zombie, screen_width/2, screen_height/2);

// hide the mouse
ShowCursor(FALSE);

// return success
return(1);

} // end Game_Init

///////////////////////////////////////////////////////////

int Game_Shutdown(void *parms,  int num_parms)
{
// this function is where you shutdown your game and
// release all resources that you allocated

for (int i = 0 ; i < 7 ; i++)
	free(Level[i]);

free(Obj_List);

// first unacquire the mouse
lpdimouse->Unacquire();

// now release the mouse
lpdimouse->Release();

// release directinput
lpdi->Release();

// kill texture memory
Destroy_BOB(&textures);
Destroy_BOB(&zombie);

// shutdonw directdraw
DDraw_Shutdown();



// return success
return(1);
} // end Game_Shutdown

///////////////////////////////////////////////////////////

int Game_Main(void *parms, int num_parms)
{
// this is the workhorse of your game it will be called
// continuously in real-time this is like main() in C
// all the calls for you game go here!

static int left_mouse_released = 0;

int index, index_x, index_y;  // looping vars
int start_map_x,start_map_y,  // map positions
    end_map_x,end_map_y;

int world_x_bound;

int world_mouse_x, world_mouse_y; // world mouse positions

int offset_x, offset_y;       // pixel offsets within cell

int temp_tile;

// check of user is trying to exit
if (KEY_DOWN(VK_ESCAPE) || KEY_DOWN(VK_SPACE))
    PostMessage(main_window_handle, WM_DESTROY,0,0);

// start the timing clock
Start_Clock();

// clear the drawing surface
DDraw_Fill_Surface(lpddsback, 0);

world_x_bound = (Level_Size - 10) * 64;

// check for movement (scrolling)
if (KEY_DOWN(VK_RIGHT))
    {
    if ((world_x+=4) >= world_x_bound)
       world_x = world_x_bound - 1;

	//if (zombie.curr_animation != ANIM_RIGHT)
 //     Set_Animation_BOB(&zombie,ANIM_RIGHT);

    } // end if
else
if (KEY_DOWN(VK_LEFT))
    {
    if ((world_x-=4) < 0)
       world_x = 0;

	//if (zombie.curr_animation != ANIM_LEFT)
 //     Set_Animation_BOB(&zombie,ANIM_LEFT);
    } // end if

// no up and down in this game!
//if (KEY_DOWN(VK_UP))
//    {
//    if ((world_y-=4) < 0)
//       world_y = 0;
//
//    } // end if
//else
//if (KEY_DOWN(VK_DOWN))
//    {
//    if ((world_y+=4) >= 448)
//       world_y = 447;
//
//    } // end if

// get the input from the mouse
lpdimouse->GetDeviceState(sizeof(DIMOUSESTATE), (LPVOID)&mouse_state);

// move the mouse cursor
mouse_x +=(mouse_state.lX);
mouse_y +=(mouse_state.lY);

// test bounds

// first x boundaries
if (mouse_x >= screen_width)
   mouse_x = screen_width-1;
else
if (mouse_x < 0)
   mouse_x = 0;

// now the y boundaries
if (mouse_y >= screen_height)
   mouse_y= screen_height-1;
else
if (mouse_y < 0)
   mouse_y = 0;

world_mouse_x = world_x + mouse_x;
//world_mouse_y = world_y + mouse_y;
world_mouse_y = mouse_y;

// compute grid coor of mouse curser
mouse_map_x = world_mouse_x/64;
mouse_map_y = world_mouse_y/64;

if (mouse_map_y >= 7) mouse_map_y = 6;

// if left mouse button is pressed, cycle through tile options
if (mouse_state.rgbButtons[0] && left_mouse_released == 0)
{
	left_mouse_released = 1;
	if (Level[mouse_map_y][mouse_map_x] == 11)
		Level[mouse_map_y][mouse_map_x] = 0;
	else if (Level[mouse_map_y][mouse_map_x] <=10)
		Level[mouse_map_y][mouse_map_x]++;

}
else if (!mouse_state.rgbButtons[0]) left_mouse_released = 0;

// compute starting map indices by dividing position by size of cell
start_map_x = world_x/64; // use >> 6 for speed, but this is clearer
//start_map_y = world_y/64; 
start_map_y = 0; 

// compute end of map rectangle for best cast i.e. aligned on 64x64 boundary
end_map_x = start_map_x + 10 - 1;
end_map_y = start_map_y + 7 - 1;


// now compute number of pixels in x,y we are within the tile, i.e
// how much is scrolled off the edge?
offset_x = -(world_x % 64);
offset_y = -(world_y % 64);

// adjust end_map_x,y for offsets
if (offset_x)
   end_map_x++;

if (offset_y)
   end_map_y++;


// set starting position of first upper lh texture
int texture_x = offset_x;
int texture_y = offset_y;

// draw the current window
for (index_y = start_map_y; index_y <= end_map_y; index_y++)
    {
    for (index_x = start_map_x; index_x <= end_map_x; index_x++)
        {
        // set position to blit
        textures.x = texture_x;
        textures.y = texture_y;
        
        // set frame
        textures.curr_frame = Level[index_y][index_x];
		
		if (textures.curr_frame >= 12) textures.curr_frame = 0;

        // draw the texture
        Draw_BOB(&textures,lpddsback);

		switch (Level[index_y][index_x])
		{
		case OBJ_START:
			Draw_Text_GDI ("START", texture_x+5, texture_y+5,RGB(0,255,0), lpddsback);
			break;
		case OBJ_ZOMBIE:
			Draw_Text_GDI ("ZOMBIE", texture_x+5, texture_y+5,RGB(0,255,0), lpddsback);
			break;
		case OBJ_DRONE:
			Draw_Text_GDI ("DRONE", texture_x+5, texture_y+5,RGB(0,255,0), lpddsback);
			break;
		case OBJ_FINISH:
			Draw_Text_GDI ("FINISH", texture_x+5, texture_y+5,RGB(0,255,0), lpddsback);
			break;
		default:
			break;
		}

		// highlight current mouse position
		if (index_y == mouse_map_y && index_x == mouse_map_x)
		{
			Draw_Rectangle (texture_x, texture_y, texture_x+2, texture_y+64, RGB(100,0,0),lpddsback);
			Draw_Rectangle (texture_x, texture_y, texture_x+64, texture_y+2, RGB(100,0,0),lpddsback);
			Draw_Rectangle (texture_x+64-2, texture_y, texture_x+64, texture_y+64, RGB(100,0,0),lpddsback);
			Draw_Rectangle (texture_x, texture_y+64-2, texture_x+64, texture_y+64, RGB(100,0,0),lpddsback);
		}

        // update texture position
        texture_x+=64;

        } // end for map_x

    // reset x postion, update y
    texture_x =  offset_x;
    texture_y += 64;

    } // end for map_y

for (index = 0 ; index < Num_Objects ; index++)
{
	Update_BOB(&Obj_List[index]);
}

// Draw mouse cursur.
Draw_Rectangle (mouse_x-2, mouse_y-2, mouse_x+2, mouse_y+2, RGB(255,255,255),lpddsback);
Draw_Rectangle (mouse_x-1, mouse_y-1, mouse_x+1, mouse_y+1, RGB(0,0,0),lpddsback);

// draw some info
Draw_Text_GDI("USE ARROW KEYS TO MOVE, <ESC> to Exit.",8,8,RGB(255,255,255),lpddsback);

sprintf(buffer,"World Position = [%d, %d]     Mouse Position = [%d, %d]", world_x, world_y, world_mouse_x, world_mouse_y);
Draw_Text_GDI(buffer,8,screen_height - 32 - 24,RGB(0,255,0),lpddsback);
sprintf(buffer,"x_bound: %d", world_x_bound);
Draw_Text_GDI(buffer,8,screen_height - 24,RGB(0,255,0),lpddsback);

// flip the surfaces
DDraw_Flip();

// sync to 30 fps
Wait_Clock(15);

// return success
return(1);

} // end Game_Main

//////////////////////////////////////////////////////////
// checks and sees if file is an actual file.
// creates the file otherwise. If nothing is in the file
// it'll fill it with an empty level.
int Prep_File (char *Level_Name)
{
	FILE *pfile;
	char size[32];

	pfile = fopen(Level_Name, "r");

	if (pfile)
	{
		// for now just assume it has valid data.
		// no need to worry about it being otherwise for scope
		// of this project.
		fclose(pfile);
		return 1;
	}
	else
	{
		pfile = fopen(Level_Name, "w");
		fwrite("30",1,2,pfile);
		fwrite("\n",1,1,pfile);
		for (int i = 0 ; i < 7 ; i++)
		{
			for(int j = 0 ; j < 30 ; j++)
			{
				fwrite("0",1,1,pfile);
			}
			fwrite("\n",1,1,pfile);
		}

		fclose(pfile);
	}

	return 1;
}


//////////////////////////////////////////////////////////
// loads level from .txt file
int Load_Level (char *Level_Name)
{
	FILE *file_handle;
	char pt[1];
	int result;
	int isize = 0;
	char size[32];

	file_handle = fopen(Level_Name, "r");
	if (file_handle == NULL)
		return 0;

	fgets (size, sizeof(size), file_handle);

	isize = atoi(size);

	while (isize > Level_Size) Expand_Level();

	for (int i = 0 ; i < 7 ; i++)
	{
		for (int j = 0 ; j < isize ; j++)
		{
			result = fgetc(file_handle);
			result = result - '0';

			if (result < 0 || result >=12) 
			{
				Level[i][j] = 0;

				//if (result >= OBJ_START)
				//	Add_Object(result, j, i);
				if (result >= OBJ_START)
					Level[i][j] = result;
			}
			else Level[i][j] = result;
		}
		// read one more for the '\n'
		fgetc(file_handle);
	}

	fclose(file_handle);

	return 0;
}


//////////////////////////////////////////////////////////////////
// saves level to .txt files
int Save_Level (char *Level_Name)
{
	FILE *file_handle;
	char pt[1];
	char size[32];
	int result;

	file_handle = fopen(Level_Name, "w");
	if (file_handle == NULL)
		return 0;

	itoa(Level_Size, size, 10);

	fwrite (size, 1, strlen(size), file_handle);
	fwrite ("\n", 1, 1, file_handle);

	for (int i = 0 ; i < 7 ; i++)
	{
		for (int j = 0 ; j < Level_Size ; j++)
		{
			pt[0] = Level[i][j] + '0';
			result = fwrite(pt, 1, 1, file_handle);
			if (result == -1)
			{
				return 0;
			}

		}

		fwrite("\n", 1, 1, file_handle);
	}

	fclose(file_handle);

	return 0;
}

//////////////////////////////////////////////////////////////////
// Expand_Level function adds 30 tiles to the current level.
int Expand_Level()
{
	int test;

	for (int i = 0 ; i < 7 ; i++)
	{
		Level[i] = (int*)realloc (Level[i], sizeof (*Level[i]) * (Level_Size + 30));

		if (Level[i] == 0) return (0);

		memset (&Level[i][Level_Size], 0 , sizeof(*Level[i]) * 30);
	}

	Level_Size = Level_Size + 30;

	return (1);
}

//////////////////////////////////////////////////////////////////
// Add Object
int Add_Object(int MobType, int worldpos_x, int worldpos_y)
{
	int pixpos_x, pixpos_y;
	int index;         // looping var
	char filename[80]; // used to build up files names


	if (Level[worldpos_y][worldpos_x] != 0)
	{
		// there's something here already, cant place object here!
		return 1;
	}

	Level[worldpos_y][worldpos_x] = MobType;

	Obj_List = (BOB*)realloc(Obj_List, (Num_Objects + 1) * sizeof(BOB));

	memset (&Obj_List[Num_Objects], 0, sizeof(BOB));

	switch (MobType)
	{
	case OBJ_START:
		break;

	case OBJ_ZOMBIE:
		// create the texture bob
		if (!Create_BOB(&Obj_List[Num_Objects],0,0,72,80,NUM_ZOMBIE_FRAMES, 
			BOB_ATTR_VISIBLE | BOB_ATTR_MULTI_ANIM,DDSCAPS_SYSTEMMEMORY))
			return 0;

		// load the frames in 2 directions, 4 frames each
		// each set of frames has a walk and a fire, frame sets
		// are loaded in counter clockwise order looking down
		// from a birds eys view or the x-z plane
		for (int direction = 0; direction < 2; direction++)
		{
			// build up file name
			sprintf(filename,"pal_Dedsp0%d.bmp",direction+1);

			// load in new bitmap file
			Load_Bitmap_File(&bitmap8bit,filename);
			
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,0+direction*4,0,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,1+direction*4,1,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,2+direction*4,2,0,BITMAP_EXTRACT_MODE_CELL);  
			Load_Frame_BOB(&Obj_List[Num_Objects],&bitmap8bit,3+direction*4,0,1,BITMAP_EXTRACT_MODE_CELL);  
			
			// unload the bitmap file
			Unload_Bitmap_File(&bitmap8bit);
			
			// set the animation sequences for skelaton
			Load_Animation_BOB(&Obj_List[Num_Objects],direction,4,(int*)zombie_anims[direction]);

		} // end for direction

		Obj_List[Num_Objects].varsF[FORCE_X] = 0;
		Obj_List[Num_Objects].varsF[FORCE_Y]  = 0;

		Set_Animation_BOB(&Obj_List[Num_Objects], ANIM_LEFT);
		Set_Anim_Speed_BOB(&Obj_List[Num_Objects], 32);

		pixpos_x = worldpos_x * 64;
		pixpos_y = worldpos_y * 64;

		if (Obj_List[Num_Objects].height > 64)
		{
			pixpos_y = pixpos_y - (Obj_List[Num_Objects].height - 64);
		}

		//Set_Pos_BOB(&Obj_List[Num_Objects], pixpos_x, pixpos_y);
		Obj_List[Num_Objects].varsI[OBJ_WORLD_X] = pixpos_x;
		Obj_List[Num_Objects].varsI[OBJ_WORLD_Y] = pixpos_y;

		Obj_List[Num_Objects].varsI[OBJ_TYPE] = MobType;

		Num_Objects++;
		break;

	case OBJ_DRONE:
		break;

	case OBJ_FINISH:
		break;

	default:
		break;
	}

	return 0;
}

// calculate everything for the bob
int Update_BOB(BOB *pBob)
{
	int remainder = 0;
	int temp_x = 0;

	if ((pBob->varsI[OBJ_WORLD_X] >= world_x + screen_width) ||
		(pBob->varsI[OBJ_WORLD_X] <= world_x - pBob->width))
	{
		// object is offscreen, dont both calculating anything
		//pBob->varsF[FORCE_Y] = 0;
		//pBob->varsF[FORCE_X] = 0;
		return 0;
	}
	else
	{
		pBob->x = pBob->varsI[OBJ_WORLD_X] - world_x;
	}


	if ((pBob->varsI[OBJ_WORLD_Y] >= world_y + screen_height) || 
		(pBob->varsI[OBJ_WORLD_Y] <= world_y - pBob->height))
	{
		// object is offscreen, dont both calculating anything
		//pBob->varsF[FORCE_Y] = 0;
		//pBob->varsF[FORCE_X] = 0;
		return 0;
	}
	else
	{
		pBob->y = pBob->varsI[OBJ_WORLD_Y] - world_y;
	}
	
	DDraw_Lock_Back_Surface();

	if (Color_Scan (pBob->x+24, pBob->y, 
				pBob->x+pBob->width-24,pBob->y+pBob->height, 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
	{
		//Draw_Text_GDI("Color_Scan = TRUE",8,screen_height - 64 - 24,RGB(0,255,0),lpddsback);
		
		//if (pBob->varsF[FORCE_Y] > 0)
			pBob->varsF[FORCE_Y] = 0;
	}
	else
	{
		//Draw_Text_GDI("Color_Scan = FALSE",8,screen_height - 64 - 24,RGB(0,255,0),lpddsback);

		pBob->varsF[FORCE_Y]+=0.2;

		if (Color_Scan (pBob->x+24, pBob->y + pBob->varsF[FORCE_Y], 
				pBob->x+pBob->width-24,pBob->y+pBob->height + pBob->varsF[FORCE_Y], 
				1, 255, // hoping this is black color
				back_buffer,back_lpitch))
		{
			// sunk into something solid, need to find exact collision.
			
			remainder = pBob->y + pBob->height;
			temp_x = pBob->x;
			
			while ((!Color_Scan(temp_x+24, remainder, temp_x+48, remainder, 1, 255, back_buffer, back_lpitch)) &&
				   (remainder <= (screen_height+pBob->height)))
				remainder++;
			
			pBob->y = remainder - pBob->height + 1; // +1 so character sits withtin floor a little.
			pBob->varsI[OBJ_WORLD_Y] = remainder - pBob->height + 1; // +1 so character sits withtin floor a little.
			pBob->varsF[FORCE_Y] = 0;
		}
	}

	
	DDraw_Unlock_Back_Surface();

	pBob->x+=pBob->varsF[FORCE_X];
	pBob->varsI[OBJ_WORLD_X]+=pBob->varsF[FORCE_X];

	pBob->y+=pBob->varsF[FORCE_Y];
	pBob->varsI[OBJ_WORLD_Y]+=pBob->varsF[FORCE_Y];

	//pBob->x= mouse_x;
	//pBob->y= mouse_y;

	Animate_BOB(pBob);
	//pBob->x = mouse_x;
	//pBob->y = mouse_y;
	Draw_BOB(pBob,lpddsback);

	//Draw_Rectangle (pBob->x+24, pBob->y, 
	//			pBob->x+pBob->width-24,pBob->y+pBob->height, 
	//				RGB(255,255,255), lpddsback);

	return 0;
}